#include "ngpc.h"
#include "carthdr.h"
#include "library.h"
#include "gusrob.c" 

// forward reference prototypes
void CopySpriteAnim(u8 AnimNumber);



#define TILE_SPRITE (1) // first tile used for Sprite
#define SPR_SPRITE (0) // sprite number used for Sprite (also 1,2 and 3)



void main()
{
   InitNGPC();
   SysSetSystemFont();

   SetBackgroundColour(RGB(0,0,0));
//   InstallTileSet(TileSet, sizeof(TileSet)/2);
   InstallTileSet(tutorial, sizeof(tutorial)/2);
   SetPalette(SPRITE_PLANE, 0, 0, RGB(10,10,5), RGB(15,0,0), RGB(0,0,0));
   SetPalette(SCR_1_PLANE, 0, 0, 0, 0, RGB(15,15,15));
   SetPalette(SCR_2_PLANE, 0, 0, RGB(15,15,15), RGB(0,15,0), RGB(0,0,15));
   LevelOne();
}


// copies the new animation onto the Sprites tiles.
void CopySpriteAnim(u8 AnimNumber)
{
   u8 i;
   u16 * TileRam = TILE_RAM;
   u16 * theSpriteAnim = (u16 *) Sprite_Tiles;

   TileRam += (TILE_SPRITE * 8);
   theSpriteAnim += (AnimNumber * 8);
   
   for (i = 0; i < 32; i ++)
   {
      TileRam[i] = *theSpriteAnim++;
   }
}

int LevelOne()
{
   u8 iLoop;
   u8 SpriteX;
   u8 SpriteY;
   u8 SpriteAnim;
   u8 SpriteBaseAnim;
   
   ClearScreen(SCR_1_PLANE);
   ClearScreen(SCR_2_PLANE);
   
   PutTile(SCR_2_PLANE, 0, 2, 1, WallTop);
   PutTile(SCR_2_PLANE, 0, 1, 2, WallLeft);
   PutTile(SCR_2_PLANE, 0, 2, 17, WallBottom);
   PutTile(SCR_2_PLANE, 0, 17, 2, WallRight);
   PutTile(SCR_2_PLANE, 0, 16, 1, WallTop);
   PutTile(SCR_2_PLANE, 0, 1, 16, WallLeft);
   PutTile(SCR_2_PLANE, 0, 17, 16, WallRight);
   PutTile(SCR_2_PLANE, 0, 1, 1, WallTopLeft);
   PutTile(SCR_2_PLANE, 0, 2, 1, BedTopLeft);
   PutTile(SCR_2_PLANE, 0, 1, 1, BedTopRight);
   PutTile(SCR_2_PLANE, 0, 1, 2, BedBottomLeft);
   PutTile(SCR_2_PLANE, 0, 2, 2, BedBottomRight);
   PutTile(SCR_2_PLANE, 0, 1, 17, WallBottomLeft);
   PutTile(SCR_2_PLANE, 0, 17, 1, WallTopRight);
   PutTile(SCR_2_PLANE, 0, 17, 17, WallBottomRight2);
   for(iLoop=3;iLoop<=15;iLoop++)
   {
   PutTile(SCR_2_PLANE, 0, iLoop, 1, WallTop);
   PutTile(SCR_2_PLANE, 0, 1, iLoop, WallLeft);
   PutTile(SCR_2_PLANE, 0, iLoop, 17, WallBottom);
   PutTile(SCR_2_PLANE, 0, 17, iLoop, WallRight);
   }

   // initialise Sprite variables
   SpriteX = 63;
   SpriteY = 63;
   SpriteAnim = 0;
   SpriteBaseAnim = 0;
   
   // set the initial sprite up
   // Note that all 4 sprites are chained together so we only have to
   // move the first one and the rest follow :-)
   SetSprite(SPR_SPRITE, TILE_SPRITE, 0, SpriteX, SpriteY, 0);
   SetSprite(SPR_SPRITE+1, TILE_SPRITE+1, 1, 8, 0, 0);
   SetSprite(SPR_SPRITE+2, TILE_SPRITE+2, 1, -8, 8, 0);
   SetSprite(SPR_SPRITE+3, TILE_SPRITE+3, 1, 8, 0, 0);

   while (1)
   {
      if ((JOYPAD & J_LEFT) && (SpriteX > 10))
      {
         ClearScreen(SCR_1_PLANE);
         CopySpriteAnim(16+(SpriteAnim * 4));
         SpriteX -= 2;
         SetSpritePosition(SPR_SPRITE, SpriteX, SpriteY);
         SpriteAnim ^= 1; // toggles anim 0->1->0
      }
      else if ((JOYPAD & J_RIGHT) && (SpriteX < 126))
      {
         ClearScreen(SCR_1_PLANE);
         CopySpriteAnim(24+(SpriteAnim * 4));
         SpriteX += 2;
         SetSpritePosition(SPR_SPRITE, SpriteX, SpriteY);
         SpriteAnim ^= 1;
      }
      else if ((JOYPAD & J_UP) && (SpriteY > 10))
      {
         ClearScreen(SCR_1_PLANE);
         CopySpriteAnim(8+(SpriteAnim * 4));
         SpriteY -= 2;
         SetSpritePosition(SPR_SPRITE, SpriteX, SpriteY);
         SpriteAnim ^= 1;
      }
      else if ((JOYPAD & J_DOWN) && (SpriteY < 125))
      {
         ClearScreen(SCR_1_PLANE);
         CopySpriteAnim(0+(SpriteAnim * 4));
         SpriteY += 2;
         SetSpritePosition(SPR_SPRITE, SpriteX, SpriteY);
         SpriteAnim ^= 1;
      }
      else if ((JOYPAD & J_DOWN) && (SpriteY > 123 & SpriteX > 124))
      {
	   LevelTwo();
      }
      else if ((JOYPAD & J_A) && (SpriteX < 26 & SpriteY < 26))
      {
         ClearScreen(SCR_1_PLANE);
         PrintString(SCR_1_PLANE, 0, 4, 9, "It's A Bed.");
         PrintString(SCR_1_PLANE, 0, 2, 10, "No Time To Rest.");
      }

      Sleep(3);
   }
}

int LevelTwo()
{
   u8 iLoop;
   u8 SpriteX;
   u8 SpriteY;
   u8 SpriteAnim;
   u8 SpriteBaseAnim;
   
   ClearScreen(SCR_1_PLANE);
   ClearScreen(SCR_2_PLANE);
   
   PutTile(SCR_2_PLANE, 0, 2, 1, WallTop);
   PutTile(SCR_2_PLANE, 0, 1, 2, WallLeft);
   PutTile(SCR_2_PLANE, 0, 2, 17, WallBottom);
   PutTile(SCR_2_PLANE, 0, 17, 2, WallRight);
   PutTile(SCR_2_PLANE, 0, 16, 17, WallBottom);
   PutTile(SCR_2_PLANE, 0, 1, 16, WallLeft);
   PutTile(SCR_2_PLANE, 0, 17, 16, WallRight);
   PutTile(SCR_2_PLANE, 0, 1, 1, WallTopLeft);
   PutTile(SCR_2_PLANE, 0, 2, 1, BedTopLeft);
   PutTile(SCR_2_PLANE, 0, 1, 1, BedTopRight);
   PutTile(SCR_2_PLANE, 0, 1, 2, BedBottomLeft);
   PutTile(SCR_2_PLANE, 0, 2, 2, BedBottomRight);
   PutTile(SCR_2_PLANE, 0, 1, 17, WallBottomLeft);
   PutTile(SCR_2_PLANE, 0, 17, 1, WallTopRight);
   PutTile(SCR_2_PLANE, 0, 17, 17, WallBottomRight);
   PutTile(SCR_2_PLANE, 0, 17, 1, WallBottomRight2);
   for(iLoop=3;iLoop<=15;iLoop++)
   {
   PutTile(SCR_2_PLANE, 0, iLoop, 1, WallTop);
   PutTile(SCR_2_PLANE, 0, 1, iLoop, WallLeft);
   PutTile(SCR_2_PLANE, 0, iLoop, 17, WallBottom);
   PutTile(SCR_2_PLANE, 0, 17, iLoop, WallRight);
   }

   // initialise Sprite variables
   SpriteX = 126;
   SpriteY = 12;
   SpriteAnim = 0;
   SpriteBaseAnim = 0;
   
   // set the initial sprite up
   // Note that all 4 sprites are chained together so we only have to
   // move the first one and the rest follow :-)
   SetSprite(SPR_SPRITE, TILE_SPRITE, 0, SpriteX, SpriteY, 0);
   SetSprite(SPR_SPRITE+1, TILE_SPRITE+1, 1, 8, 0, 0);
   SetSprite(SPR_SPRITE+2, TILE_SPRITE+2, 1, -8, 8, 0);
   SetSprite(SPR_SPRITE+3, TILE_SPRITE+3, 1, 8, 0, 0);

   while (1)
   {
      if ((JOYPAD & J_LEFT) && (SpriteX > 10))
      {
         ClearScreen(SCR_1_PLANE);
         CopySpriteAnim(16+(SpriteAnim * 4));
         SpriteX -= 2;
         SetSpritePosition(SPR_SPRITE, SpriteX, SpriteY);
         SpriteAnim ^= 1; // toggles anim 0->1->0
      }
      else if ((JOYPAD & J_RIGHT) && (SpriteX < 126))
      {
         ClearScreen(SCR_1_PLANE);
         CopySpriteAnim(24+(SpriteAnim * 4));
         SpriteX += 2;
         SetSpritePosition(SPR_SPRITE, SpriteX, SpriteY);
         SpriteAnim ^= 1;
      }
      else if ((JOYPAD & J_UP) && (SpriteY > 10))
      {
         ClearScreen(SCR_1_PLANE);
         CopySpriteAnim(8+(SpriteAnim * 4));
         SpriteY -= 2;
         SetSpritePosition(SPR_SPRITE, SpriteX, SpriteY);
         SpriteAnim ^= 1;
      }
      else if ((JOYPAD & J_DOWN) && (SpriteY < 125))
      {
         ClearScreen(SCR_1_PLANE);
         CopySpriteAnim(0+(SpriteAnim * 4));
         SpriteY += 2;
         SetSpritePosition(SPR_SPRITE, SpriteX, SpriteY);
         SpriteAnim ^= 1;
      }
      else if ((JOYPAD & J_A) && (SpriteX < 26 & SpriteY < 26))
      {
         ClearScreen(SCR_1_PLANE);
         PrintString(SCR_1_PLANE, 0, 4, 9, "It's A Bed.");
         PrintString(SCR_1_PLANE, 0, 2, 10, "No Time To Rest.");
      }

      else if ((JOYPAD & J_UP) && (SpriteY < 12 & SpriteX > 124))
      {
	   LevelOneReturn();
      }

      Sleep(3);
   }
}

int LevelOneReturn()
{
   u8 iLoop;
   u8 SpriteX;
   u8 SpriteY;
   u8 SpriteAnim;
   u8 SpriteBaseAnim;
   
   ClearScreen(SCR_1_PLANE);
   ClearScreen(SCR_2_PLANE);
   
   PutTile(SCR_2_PLANE, 0, 2, 1, WallTop);
   PutTile(SCR_2_PLANE, 0, 1, 2, WallLeft);
   PutTile(SCR_2_PLANE, 0, 2, 17, WallBottom);
   PutTile(SCR_2_PLANE, 0, 17, 2, WallRight);
   PutTile(SCR_2_PLANE, 0, 16, 1, WallTop);
   PutTile(SCR_2_PLANE, 0, 1, 16, WallLeft);
   PutTile(SCR_2_PLANE, 0, 17, 16, WallRight);
   PutTile(SCR_2_PLANE, 0, 1, 1, WallTopLeft);
   PutTile(SCR_2_PLANE, 0, 2, 1, BedTopLeft);
   PutTile(SCR_2_PLANE, 0, 1, 1, BedTopRight);
   PutTile(SCR_2_PLANE, 0, 1, 2, BedBottomLeft);
   PutTile(SCR_2_PLANE, 0, 2, 2, BedBottomRight);
   PutTile(SCR_2_PLANE, 0, 1, 17, WallBottomLeft);
   PutTile(SCR_2_PLANE, 0, 17, 1, WallTopRight);
   PutTile(SCR_2_PLANE, 0, 17, 17, WallBottomRight2);
   for(iLoop=3;iLoop<=15;iLoop++)
   {
   PutTile(SCR_2_PLANE, 0, iLoop, 1, WallTop);
   PutTile(SCR_2_PLANE, 0, 1, iLoop, WallLeft);
   PutTile(SCR_2_PLANE, 0, iLoop, 17, WallBottom);
   PutTile(SCR_2_PLANE, 0, 17, iLoop, WallRight);
   }

   // initialise Sprite variables
   SpriteX = 125;
   SpriteY = 124;
   SpriteAnim = 0;
   SpriteBaseAnim = 0;
   
   // set the initial sprite up
   // Note that all 4 sprites are chained together so we only have to
   // move the first one and the rest follow :-)
   SetSprite(SPR_SPRITE, TILE_SPRITE, 0, SpriteX, SpriteY, 0);
   SetSprite(SPR_SPRITE+1, TILE_SPRITE+1, 1, 8, 0, 0);
   SetSprite(SPR_SPRITE+2, TILE_SPRITE+2, 1, -8, 8, 0);
   SetSprite(SPR_SPRITE+3, TILE_SPRITE+3, 1, 8, 0, 0);

   while (1)
   {
      if ((JOYPAD & J_LEFT) && (SpriteX > 10))
      {
         ClearScreen(SCR_1_PLANE);
         CopySpriteAnim(16+(SpriteAnim * 4));
         SpriteX -= 2;
         SetSpritePosition(SPR_SPRITE, SpriteX, SpriteY);
         SpriteAnim ^= 1; // toggles anim 0->1->0
      }
      else if ((JOYPAD & J_RIGHT) && (SpriteX < 126))
      {
         ClearScreen(SCR_1_PLANE);
         CopySpriteAnim(24+(SpriteAnim * 4));
         SpriteX += 2;
         SetSpritePosition(SPR_SPRITE, SpriteX, SpriteY);
         SpriteAnim ^= 1;
      }
      else if ((JOYPAD & J_UP) && (SpriteY > 10))
      {
         ClearScreen(SCR_1_PLANE);
         CopySpriteAnim(8+(SpriteAnim * 4));
         SpriteY -= 2;
         SetSpritePosition(SPR_SPRITE, SpriteX, SpriteY);
         SpriteAnim ^= 1;
      }
      else if ((JOYPAD & J_DOWN) && (SpriteY < 125))
      {
         ClearScreen(SCR_1_PLANE);
         CopySpriteAnim(0+(SpriteAnim * 4));
         SpriteY += 2;
         SetSpritePosition(SPR_SPRITE, SpriteX, SpriteY);
         SpriteAnim ^= 1;
      }
      else if ((JOYPAD & J_DOWN) && (SpriteY > 123 & SpriteX > 124))
      {
	   LevelTwo();
      }
      else if ((JOYPAD & J_A) && (SpriteX < 26 & SpriteY < 26))
      {
         ClearScreen(SCR_1_PLANE);
         PrintString(SCR_1_PLANE, 0, 4, 9, "It's A Bed.");
         PrintString(SCR_1_PLANE, 0, 2, 10, "No Time To Rest.");
      }

      Sleep(3);
   }
}